/*
 * Copyright (c) 2016-2019 Marco Hladik <marco@icculus.org>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF MIND, USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
 * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

float(entity foo, float chanid) getchannellevel = #0;

/* This really shouldn't be here, but it'll be fine for the time being */
.int initedsci;
float Scientist_PreDraw(void)
{
	/* Only do this once whenever the ent pops into view */
	if (!self.initedsci) {
		setcustomskin(self, "", sprintf("geomset 1 %d\n", self.colormod[0]));
		self.initedsci = TRUE;
	}
	
	self.bonecontrol5 = getchannellevel(self, CHAN_VOICE) * 20;

	/* HACK: We're abusing this networked field, so reset */
	self.colormod = [0,0,0];
	addentity(self);
	return PREDRAW_NEXT;
}
float Scientist_Update(float new)
{
	if (new) {
		self.predraw = Scientist_PreDraw;
		self.drawmask = MASK_ENGINE;
	}
	return TRUE;
}

/*
=================
Client_Init

Comparable to worldspawn in SSQC in that it's mostly used for precaches
=================
*/
void Client_Init(float apilevel, string enginename, float engineversion)
{
	precache_model("sprites/640hud1.spr");
	precache_model("sprites/640hud2.spr");
	precache_model("sprites/640hud3.spr");
	precache_model("sprites/640hud4.spr");
	precache_model("sprites/640hud5.spr");
	precache_model("sprites/640hud6.spr");
	precache_model("sprites/chainsaw.spr");
	precache_model("sprites/hammer.spr");
	precache_model("sprites/w_cannon.spr");

	BEAM_TRIPMINE = particleeffectnum("beam_tripmine");

	/* FIXME: Replace with manual networking once I've got time? */
	deltalisten("models/scientist.mdl", Scientist_Update, 0);
}

void Client_InitDone(void)
{
}

void Game_RendererRestarted(string rstr)
{
	
}
